/* -*-C-*- xlimits.h */
/**********************************************************************/
/******************************* xlimits ********************************/
/**********************************************************************/

/* $Id: xlimits.h,v 1.1 1992/10/19 18:30:14 beebe Exp beebe $*/

#ifndef XLIMITS_H_DEFINED_
#define XLIMITS_H_DEFINED_

/***********************************************************************
This file includes the system limits.h file, where available.
***********************************************************************/

#if HAVE_LIMITS_H
#include <limits.h>
#else /* NOT HAVE_LIMITS_H */

/* The following values are appropriate for 16-bit (IBM PC) and 32-bit
machines.  For other word lengths, almost all values will require changes.
Fortunately, almost all C implementations have limits.h. */

#define	CHAR_BIT		((int)0x8) 	/* bits in a char */
#define	SCHAR_MIN		(-SCHAR_MAX - 1)/* min int signed char */
#define	SCHAR_MAX		((int)0x7F)	/* max int signed char */
#define	UCHAR_MAX		((unsigned int)0xFF)
						/* max int unsigned char */
#define	CHAR_MIN		(-CHAR_MAX - 1)	/* min int char */
#define	CHAR_MAX		((int)0x7F)	/* max int char */
#define	SHRT_MIN		(-SHRT_MAX - 1)	/* min short */
#define	SHRT_MAX		((int)0x7FFF)	/* max short */
#define	USHRT_MAX		((unsigned int)0xFFFF) /* max unsigned short */

#if OS_PCDOS
#define	INT_MIN			SHRT_MIN	/* min int */
#define	INT_MAX			SHRT_MAX	/* max int */
#define	UINT_MAX		USHRT_MAX	/* max unsigned int */
#else /* NOT OS_PCDOS */
#define	INT_MIN			(-INT_MAX - 1)	/* min int */
#define	INT_MAX			((int)0x7FFFFFFF) /* max int */
#define	UINT_MAX		((unsigned int)0xFFFFFFFF)
						/* max unsigned int */
#endif /* OS_PCDOS */

#define	LONG_MIN		(-LONG_MAX - 1L) /* min long */
#define	LONG_MAX		((long)0x7FFFFFFF) /* max long */
#define	ULONG_MAX		((unsigned long)0xFFFFFFFF)
						/* max unsigned long */
#define	MB_LEN_MAX		((int)4)	/* max number of bytes */
						/* in a multibyte character */
						/* NB: compiler-dependent! */

/* These values are the minimum required by POSIX.  A particular system
may support larger values. */

#define _POSIX_ARG_MAX		((int)4096)	/* bytes in args to exec() */
#define _POSIX_CHILD_MAX	((int)6)	/* processes per user id */
#define _POSIX_LINK_MAX		((int)8)	/* max # links per file */
#define _POSIX_MAX_CANON	((int)255)	/* bytes in terminal canonical
						   input queue */
#define _POSIX_MAX_INPUT	((int)255)	/* bytes of avail space in
						   terminal queue */
#define _POSIX_NAME_MAX		((int)14)	/* bytes in a filename */
#define _POSIX_NGROUPS_MAX	((int)0)	/* simultaneous supplementary
						   group ids */
#define _POSIX_OPEN_MAX		((int)16)	/* open files per process */
#define _POSIX_PATH_MAX		((int)255)	/* bytes in pathname */
#define _POSIX_PIPE_BUF		((int)512)	/* bytes written atomically
						   to pipe */

#endif /* HAVE_LIMITS_H */

#endif /* XLIMITS_H_DEFINED_ */
